﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.dateTimePicker1.Value = DateTime.Now;
            this.setDateCell();
        }

        private void dateTimePicker1_ValueChanged(object sender, EventArgs e)
        {
            this.setDateCell();
        }

        private void setDateCell()
        {
            this.c1FlexGrid1.Rows.RemoveRange(1, this.c1FlexGrid1.Rows.Count - 1);

            DateTime startDate =
                new DateTime(this.dateTimePicker1.Value.Year,
                    this.dateTimePicker1.Value.Month,
                    1);

            DateTime value = startDate;

            while ( value.Month == startDate.Month )
            {
                this.c1FlexGrid1.AddItem(value.ToShortDateString());
                value = value.AddDays(1);
            }
        }

        /// <summary>
        /// Returns the connection string of the database.
        /// </summary>
        /// <returns></returns>
        private string getConnectionString()
        {
            string connectionString = string.Empty;
            connectionString += "(local)\\Developer2005;";
            connectionString += "Initial Catalog = Codezine;";
            connectionString += "Integrated Security = SSPI;";

            return connectionString;
        }

        private void RegistrationButton_Click(object sender, EventArgs e)
        {

            SqlConnection connection = new SqlConnection(this.getConnectionString());

            // Open database connection.
            connection.Open();

            SqlCommand command = new SqlCommand();
            command.Connection = connection;
            command.CommandType = CommandType.Text;

            // Delete data.
            DateTime selectedMonth
                = new DateTime(this.dateTimePicker1.Value.Year, this.dateTimePicker1.Value.Month, 1);

            command.CommandText =
                string.Format("DELETE FROM Sales WHERE Date >= '{0}' AND Date < '{1}'", 
                selectedMonth, 
                selectedMonth.AddMonths(1));
            command.ExecuteNonQuery();
            
            for (int i = 1; i < this.c1FlexGrid1.Rows.Count; i++)
            {
                if (this.c1FlexGrid1[i, 1] != null
                    || this.c1FlexGrid1[i, 2] != null)
                {
                    string insert = 
                        string.Format("INSERT Sales (Date, Proceeds, Payments, GrossMargin, GrossMarginRate) VALUES ('{0}', {1}, {2}, {3}, {4})",
                        this.c1FlexGrid1[i, 0],
                        this.c1FlexGrid1[i, 1] == null ? 0 : this.c1FlexGrid1[i, 1],
                        this.c1FlexGrid1[i, 2] == null ? 0 : this.c1FlexGrid1[i, 2],
                        this.c1FlexGrid1[i, 3],
                        this.c1FlexGrid1[i, 4]);

                    command.CommandType = CommandType.Text;
                    command.CommandText = insert;
                    command.ExecuteNonQuery();
                }
            }

            // Dispose command.
            command.Dispose();

            // Close database connection.
            connection.Close();
            connection.Dispose();

            MessageBox.Show("Data has been written to the database.");
        }

        private void ReadButton_Click(object sender, EventArgs e)
        {

            SqlConnection connection = new SqlConnection(this.getConnectionString());

            // Open database connection.
            connection.Open();

            // Generate an instance of SqlCommand from SqlConnection. 
            SqlCommand command = connection.CreateCommand();

            DateTime selectedMonth 
                = new DateTime(this.dateTimePicker1.Value.Year, this.dateTimePicker1.Value.Month, 1);

            string selectSQL 
                = string.Format("SELECT Date, Proceeds, Payments, GrossMargin, GrossMarginRate FROM Sales"
                                    + " WHERE Date >= '{0}' AND Date < '{1}'"
                                    + " ORDER BY Date", selectedMonth, selectedMonth.AddMonths(1));

            // Set the SQL command to be executed.
            command.CommandText = selectSQL;

            // Execute the specified SQL command and create a SQLDataReader.
            SqlDataReader reader = command.ExecuteReader();

            // Dispose command. 
            command.Dispose();

            // Move to the next record. 
            while (reader.Read())
            {
                DateTime dbDate = Convert.ToDateTime(reader["Date"]);

                this.c1FlexGrid1[dbDate.Day, 1] = reader["Proceeds"];
                this.c1FlexGrid1[dbDate.Day, 2] = reader["Payments"];
                this.c1FlexGrid1[dbDate.Day, 3] = reader["GrossMargin"];
                this.c1FlexGrid1[dbDate.Day, 4] = reader["GrossMarginRate"];
            }

            // Close reader.
            reader.Close();

            // Close database connection.
            connection.Close();
            connection.Dispose();

            MessageBox.Show("Data has been loaded to the grid.");
        }

        private void c1FlexGrid1_AfterEdit(object sender, C1.Win.C1FlexGrid.RowColEventArgs e)
        {
            double proceeds = this.c1FlexGrid1[e.Row, 1] == null
                                ? 0 : double.Parse(this.c1FlexGrid1[e.Row, 1].ToString());
            double payments = this.c1FlexGrid1[e.Row, 2] == null
                                ? 0 : double.Parse(this.c1FlexGrid1[e.Row, 2].ToString());
            double grossMargin = proceeds - payments;
            this.c1FlexGrid1[e.Row, 3] = grossMargin;
            this.c1FlexGrid1[e.Row, 4] = proceeds != 0 ? grossMargin / proceeds : 0;
        }
               
    }
}
